/* -----------------------------------------
	117 Responsive Simplit3 Ver 2.0
	2021.05.05
	https://blogpack.tistory.com
	email: extflash@gmail.com
	Distributed under MIT License
----------------------------------------- */

let isMobile = false;//모바일 기기 체크 확인 변수
let isSidebarCategory = true;//사이드바 카테고리 확인 변수
let body = null;
let isSquareThumbnail = false; //정사각 썸네일 여부

window.addEventListener('DOMContentLoaded', function(){

	isSidebarCategory = document.querySelector('html.category-side') != null ? true:false;//카테고리 방향 결정
	isSquareThumbnail = document.querySelector('html.square-thumbnail') != null ? true:false;//카테고리 방향 결정

	checkMobile(); // 모바일 체크
	setMobileCategory(); //모바일 메뉴로 카테고리 붙였다 뗌
	modeSidebar();
	
	html = document.querySelector('html');
			
	if(html.classList.contains('place-thumbnail')){
		setNoImage(); //이미지 없는 썸네일 배경 이미지 처리
	}
	checkSearchBar(); //검색바 감춤처리

	let el_morepage = document.querySelector(".paging-view-more");
	if( el_morepage != null){
		viewMore();
	}	

	/* 스크롤 할 때 오프셋 높이 제한 값 이상이면 탑 이동 버튼 표시 */
	window.addEventListener("scroll", function(event){
		let height = window.pageYOffset;
		let btntop = document.querySelector('.btn-top');
		if ( btntop != null ){
			if(height > 160){
				document.querySelector('#header').classList.add('on');
				if(btntop.classList.contains('hideanim')){
					btntop.classList.remove('hideanim');
					event.stopPropagation();
				}
			}else{
				document.querySelector('#header').classList.remove('on');
				btntop.classList.add('hideanim');
			}
		}
	});

	
	/* 페이지 안의 이미지 "src" 속성을 "data-src" 속성으로 옮기고 "lazyload" 클래스 부여 */
	if(document.querySelector('html.seo-lazyload') != null){
		const imgs = document.querySelectorAll('#content img');
		if(imgs.length > 0){
			imgs.forEach(function(img){
				if(img.getAttribute('srcset') != null){
					img.setAttribute('data-srcset', img.getAttribute('srcset'));
					if(isSquareThumbnail){
						img.setAttribute('srcset', 'data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==');
					}else{
						img.setAttribute('srcset', 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAMAAAACCAQAAAA3fa6RAAAADklEQVR42mNkAANGCAUAACMAA2w/AMgAAAAASUVORK5CYII=');
					}
				}
				if(img.getAttribute('src') != null){
					img.setAttribute('data-src', img.getAttribute('src'));
					if(isSquareThumbnail){
						img.setAttribute('src', 'data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==');
					}else{
						img.setAttribute('src', 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAMAAAACCAQAAAA3fa6RAAAADklEQVR42mNkAANGCAUAACMAA2w/AMgAAAAASUVORK5CYII=');
					}
				}
				img.classList.add('lazyload');
			});
		}

		//"src"를 처리함 이미지 태그에 프로미스 비동기 함수를 매핑
		[...document.querySelectorAll('#content img.lazyload')].forEach(async img => {
			await onElementVisible(img);
			if(img.getAttribute('src') != null){
				img.setAttribute('src', img.getAttribute('data-src'));
			}
			if(img.getAttribute('srcset') != null){
				img.setAttribute('srcset', img.getAttribute('data-srcset'));
			}
		});


		/* 이미지가 뷰포트 안이면 비동기로 이미지 로딩 */
		function onElementVisible(element, options = {}){
			// 기본 교차 옵저버 옵션 설정
			const intersectionObserverOptions = {
				rootMargin: '0px',
				threshold: 0.5,
				...options,
			};

			//이미지가 처음 화면 도큐먼트 뷰포트 영역 안에 표시되면 리졸브 콜백을 실행하는 프로미스 객체를 리턴
			return new Promise(resolve => {
				//옵저버 객체 생성
				const observer = new IntersectionObserver(async entries => {
					// 뷰포트와 교차한 목록
					const [entry] = entries;

					// 도큐먼트 루트와 교차했는지 체크
					if (entry.isIntersecting) {
						// 프로미스 리졸브 실행
						resolve();
						// 옵저버를 종료해 한번만 실행되도록 함
						observer.disconnect();
					}
				}, intersectionObserverOptions);
				observer.observe(element);
			});
		}		
	}

	//모바일 메뉴 아이콘 클릭 처리
	document.querySelector(".mobile-menu").addEventListener("click", function(event){

		modeSidebar();

		const events = ["scroll","touchmove","touchend","mousewheel"];

		let mobile_menu = document.querySelector(".mobile-menu");
		if ( mobile_menu.classList.contains("on") ){

			//모바일 사이드 메뉴 오프시 락 이벤트 제거
			for(let i = 0;i < events.length;i++){
				document.querySelector('#dimmed').removeEventListener(events[i], handleLockEvent);
			}

			document.querySelector('.search').style.display = 'block';
			if(document.querySelector('#header > .title') != null){
				document.querySelector('#header > .title').style.display = 'block';
			}
			mobile_menu.classList.remove("on");
			document.querySelector("#header .menu").classList.remove("on");
			document.querySelector("#dimmed").remove();
			if(document.querySelector('.hideanim') == null){
				document.querySelector("#header").classList.add("on");
			}
			if(isMobile){
				document.querySelector('#header > .inner > .title').style.display = 'block';
				document.querySelector('.social-link-wrap').style.display = 'block';
				document.querySelector('.content-wrap').style.display = 'block';
			}
		} else {
			document.querySelector('.search').style.display = 'none';
			if(document.querySelector('#header > .title') != null){
				document.querySelector('#header > .title').style.display = 'none';
			}
			mobile_menu.classList.add("on");
			document.querySelector("#header .menu").classList.add("on");
			document.querySelector("#header").classList.remove('on');

			document.querySelector("body").insertAdjacentHTML('beforeend','<div id="dimmed"></div>');
			document.querySelector('#dimmed').addEventListener("click", function(){
				document.querySelector(".mobile-menu").dispatchEvent(new Event('click'));
			});
			if(isMobile){
				document.querySelector('#header > .inner > .title').style.display = 'none';
				document.querySelector('.social-link-wrap').style.display = 'none';
				document.querySelector('.content-wrap').style.display = 'none';
			}			
			//모바일 사이드 메뉴 온시 컨텐츠 스크롤 락
			for(let i = 0;i < events.length;i++){
				document.querySelector('#dimmed').addEventListener(events[i], handleLockEvent);
			}
		}
	});

	//리사이즈 처리
	window.addEventListener("resize", function(){
		checkMobile();
		setMobileCategory();
		modeSidebar();
	});
	
	//1단 검색버튼
	document.querySelector('#wrap .search').addEventListener("click", function(event){
		let search = document.querySelector('#wrap .search');
		if ( !search.classList.contains("on") ){
			search.classList.add("on");
			document.querySelector('#wrap .search input').focus();
			if(document.querySelector(".mobile-menu.on") != null){
				document.querySelector('.mobile-menu.on').dispatchEvent(new Event('click'));
			}

			if(isMobile){
				if(document.querySelector('.social-link-wrap') != null){
					document.querySelector('.social-link-wrap').style.display = 'none';
				}
				if(document.querySelector('#header.on .title') != null){
					document.querySelector('#header.on .title').style.display = 'none';
				}
			}				
			return false;
		}
	});
		
	//검색박스 닫기 버튼 클릭 처리
	document.querySelector('.close-search').addEventListener("click", function(event){
			document.querySelector("#wrap .search").classList.remove("on");
			if(isMobile){
				if(document.querySelector('.social-link-wrap') != null){
					document.querySelector('.social-link-wrap').style.display = 'block';
				}
				if(document.querySelector('#header.on .title') != null){
					document.querySelector('#header.on .title').style.display = 'block';
				}
			}				
			event.stopPropagation();
			return false;
	});


	//모바일 테이블과 아이프레임 처리
	if ( isMobile && document.querySelector(".entry-content") != null ){
		mobileTable();
		iframeWrap();
	}

	//탑으로 애니메이션 스크롤 하는 버튼
	document.querySelector('.btn-top').addEventListener('click', function(){
		window.scroll({top: 0,behavior: 'smooth'});
		//scrollTo(document.querySelector("body"), 0, 600);
		return false;
	});

});//DOMContentLoaded

/* -----------------------------------
	티스토리 스킨용 공통 사용 함수
   ----------------------------------- */

// 쿠키 얻기
function getCookie(name){
	name = new RegExp(name + '=([^;]*)');
	return name.test(document.cookie) ? unescape(RegExp.$1) : '';
}

//터치 이벤트 락 핸들 함수
function handleLockEvent(event){
	event.preventDefault();
	event.stopPropagation();
	return false;
}

// 이미지 없는 썸네일 자리 채우기용 투명 이미지 태그 붙이기
function setNoImage(){
	const posts = document.querySelectorAll(".post-item, .cover-list ul li, .recent-posts > li");
	if(posts.length && posts.length > 0){
		for(let i = 0;i < posts.length;i++){
			if(posts[i].querySelector('.thum') != null && posts[i].querySelector('.thum img') == null){
				if(isSquareThumbnail){
					posts[i].querySelector('.thum').innerHTML = '<img src="data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==">' + posts[i].querySelector('.thum').innerHTML;
				}else{
					posts[i].querySelector('.thum').innerHTML = '<img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAMAAAACCAQAAAA3fa6RAAAADklEQVR42mNkAANGCAUAACMAA2w/AMgAAAAASUVORK5CYII=">' + posts[i].querySelector('.thum').innerHTML;
				}
				posts[i].classList.add('noimage');
			}
		}
	}
}

//모바일 사이드바로 카테고리 이동
function setMobileCategory(){
	if(document.querySelector('#header .category-menu').style.display == 'none' || isSidebarCategory || isMobile){
		if(document.querySelectorAll('.category-menu > .inner > .category').length){
			if(document.querySelector('#profile') != null){
				document.querySelector('#profile').insertAdjacentHTML('afterend','<div id="mobile_category" class="box_aside"><div class="tit_aside">Category</div></div>');
			}else{
				document.querySelector('#wrap_sidebar1').insertAdjacentHTML('afterbegin','<div id="mobile_category" class="box_aside"><div class="tit_aside">Category</div></div>');
			}
			let mc = document.querySelector('.category-menu > .inner > .category');
			if(mc != null){				
				document.querySelector('#mobile_category').append(mc);
			}
		}
		//document.querySelector('#header .category-menu').style.display = 'block';
	}else{
		if(document.querySelector('#wrap_sidebar1 > #mobile_category') != null){
			let mc = document.querySelector('#mobile_category .category');
			if(mc != null){
				document.querySelector('.category-menu > .inner').prepend(mc);
				document.querySelector('#mobile_category').remove();
			}
		}
	}
}

//모바일 메뉴 펼쳐졌으면 클릭 트리거
function clickMobileMenu(){
	if(document.querySelector('.sidebar').style.display == 'block' && document.querySelector('.mobile-menu') != null){
		document.querySelector('.mobile-menu').dispatchEvent(new Event('click'));
	}
}

//검색폼 펼쳐졌으면 감춤 처리
function checkSearchBar(){
	if(isMobile && document.querySelector('.search.on') != null){
		//모바일이면 검색 펼침 닫기
		document.querySelector('.search.on').classList.remove('on');
		document.querySelector('.search .attach').classList.remove('attach');
	}		
}

//모바일 사이드바 이동
function modeSidebar(){
	if(isMobile){
		//사이드바1 헤더로 이동
		if(document.querySelector('#sidebar #wrap_sidebar1') != null){
			let sidebar = document.querySelector('#wrap_sidebar1');
			document.querySelector('#header_sidebar .inner').prepend(sidebar);
		}
	}else{
		//사이드바1 사이드로 이동
		if(document.querySelector('#header_sidebar #wrap_sidebar1') != null){
			let sidebar = document.querySelector('#wrap_sidebar1');
			document.querySelector('#sidebar .inner').prepend(sidebar);
		}
	}		
}

// 더보기 버튼 UI 초기화
function viewMoreInit(){
	let nextUrl = document.querySelector(".pagination .next").getAttribute("href");
	let posts = document.querySelectorAll(".pagination a")
	if(posts && posts.length > 0){
		posts.forEach(function(post){
			post.style.display = 'none';
		});
	}
	if( nextUrl ){
		document.querySelector(".pagination .inner").insertAdjacentHTML('beforeend','<a href="javascript:void(0)" class="btn view-more"><span>더보기<span></a>');
		document.querySelector(".pagination .view-more").addEventListener("click", function(){
			loadNext(nextUrl);// 비동기 다음 페이지 가져오기
			return false;
		});
	}
}

// 더보기 방식 버튼 최초 초기화
function viewMore(){
	let el_items = document.querySelectorAll('.post-item');
	let el_viewmore = document.querySelectorAll('.paging-view-more');
	if ( el_items.length && el_viewmore.length ){
		viewMoreInit(); // 더보기 버튼 UI 초기화
	} else {
		let current_num = document.querySelector(".pagination .selected").textContent,
			total_num = document.querySelector(".pagination .next") != null ? document.querySelector(".pagination .next").previousElementSibling.textContent : document.querySelector(".pagination a:last").textContent;
		
		document.querySelector(".pagination .inner").insertAdjacentHTML('beforeend','<span class="current">'+current_num+'/'+total_num+'</span>');
		document.querySelector(".pagination .inner .current").style.color = document.querySelector('.title h1 a').style.color;
	}
}

// 비동기 다음 페이지 목록 가져오기
function loadNext(url){
	let xmlhttp = getXMLHttpRequest();
	xmlhttp.onreadystatechange = function() {
		if (this.readyState == 4 && this.status == 200) {
		
		let res = document.body.appendChild(document.createElement("div"));
		res.style.display = "none";
		res.innerHTML = this.responseText;

		let nextPostItems = res.querySelectorAll(".post-item"),
		paginationInner = res.querySelector(".pagination").innerHTML;

		if ( nextPostItems && nextPostItems.length > 0 ){
			nextPostItems.forEach(function(post){
				document.querySelector("#content .inner").append(post);
			});
			document.querySelector(".pagination").innerHTML = paginationInner;
			if(document.querySelector('html.place-thumbnail') != null){
				setNoImage(); //이미지 없는 썸네일 배경 이미지 처리
			}
			viewMoreInit(); // 더보기 버튼 UI 초기화
		} else {
			document.querySelector('.pagination').remove();
		}

		}
	};
	xmlhttp.open("GET", url, true);
	xmlhttp.send();
}

// 모바일기기체크 - @media로 체크
function checkMobile(){
	/*
	let mm = document.querySelector('.mobile-menu');
	if( document.querySelector('.mobile-menu').style.display == 'block') {
		isMobile = true;
	}else{
		isMobile = false;
	}
	*/
	if ( window.innerWidth <= 1023 ){ 
		isMobile = true;
	}else{
		isMobile = false;
	}	
}

// 모바일에서 테이블 감싸서 스와이프로 볼 수 있게 함.
function mobileTable(){
	let tables = document.querySelectorAll(".entry-content table");

	if( tables.length > 0 ){
		for(let i = 0;i < tables.length;i++){
			if ( (tables[i].style.tableLayout === "fixed" || tables[i].classList.contains("txc-table")) && !tables[i].parentElement.classList.contains("table-wrap") ){
				tables[i].outerHTML = ('<div class="table-wrap">'+tables[i].outerHTML+'</div>');
			}
		};
	}
}

// 모바일에서 아이프레임 감싸서 스와이프로 볼 수 있게 함.
function iframeWrap(){
	let iframes = document.querySelectorAll(".entry-content iframe");

	if( iframes.length > 0 ){
		for(let i = 0;i < iframes.length;i++){
			if ( !iframes[i].parentElement.classList.contains("iframe-wrap") ){
				iframes[i].outerHTML = '<div class="iframe-wrap">'+iframes[i].outerHTML+'</div>';
			}
		};
	}
}

//animate 대체 부드러운 스크롤 탑 애니메이션 처리
function scrollTo(element, to, duration) {
    var start = element.scrollTop,
        change = to - start,
        currentTime = 0,
        increment = 20;
        
    var animateScroll = function(){        
        currentTime += increment;
        var val = Math.easeInOutQuad(currentTime, start, change, duration);
        element.scrollTop = val;
        if(currentTime < duration) {
            setTimeout(animateScroll, increment);
        }
    };
    animateScroll();
}

//t = current time
//b = start value
//c = change in value
//d = duration
Math.easeInOutQuad = function (t, b, c, d) {
  t /= d/2;
	if (t < 1) return c/2*t*t + b;
	t--;
	return -c/2 * (t*(t-2) - 1) + b;
};